//---------------------------------------------------------------------------

#include "tnlib.h"
#pragma hdrstop

#include "ExpTemp.h"
#include "prgstrlib.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

//---------------------------------------------------------------------------
// ev[g̉
// $n	: A
// \r   : A
// \n	: s
// \t	: ^u

ExpTempParam::ExpTempParam()
{
	memset(this, 0, sizeof(*this));
	crlfchar = '\n';
}

ExpTempParam::~ExpTempParam()
{
	if (Buffer)
		delete[] Buffer;
}

void ExpTempParam::ClearVar()	// ϐ̏
{
	memset( Var0, 0, sizeof(Var0) );
	memset( VarA, 0, sizeof(VarA) );
	memset( Vara, 0, sizeof(Vara) );
}

tchar *ExpandTemplate1( const tchar *sp, const tchar **nextsp, tchar *dp, ExpTempParam &et, tchar endchar, tchar brchar, tchar delim, bool eva );
bool EvaluateTemplate( const tchar *str, const tchar **nextstr, int *value );
tchar *ConvertCharCode(const tchar *ctype, const tchar *src, tchar *dst, int dstlen);

// -- ExpandTemplate() --
// et.Buffer^ꍇAet.Bufferlengthet.BufferLengthɗ^
// et.Buffer^ꍇAExpandTemplate̗͂̈𗘗p(new char[]Ŋmۂꂽ̂Ɖ)
bool ExpandTemplate( ExpTempParam &et )
{
	et.brcount = 0;
	et.LastValue = 0;
	if ( !et.Buffer ){
		et.Buffer = new tchar[ 2048 ];
		if ( !et.Buffer ) return false;	// out of memory
		et.BufferLength = 2048;
	}
	const tchar *sp;
	for (;;){
		et.EndBuffer = et.Buffer + (et.BufferLength-1);
		tchar *ret = ExpandTemplate1( et.temp, &sp, et.Buffer, et, 0, 0, 0, true );
		if (!ret){
			int newsize = et.BufferLength+et.RequiredLen;
			newsize = (newsize + 1023) & ~(1024-1);
			tchar *newbuf = new tchar[newsize];
			if (!newbuf){
				if (et.Buffer){
					delete[] et.Buffer;
					et.BufferLength = 0;
				}
				return false;	// No memory.
			}
			et.Buffer = newbuf;
			et.BufferLength = newsize;
			continue;	// retry
		}
		break;
	}
	et.BufferLength = et.EndBuffer - et.Buffer + 1;
	return true;
}

#define	ET_REALLOC(ptr,addlen) \
	if ( ptr + (addlen) + 128 > et.EndBuffer ){ \
		et.RequiredLen = addlen+128; \
		return NULL; \
	}

// return : next dp. buffer sizesNULLԂBĂяoet.Buffer̃TCY𑝂₷Kv
// brchar : ΂ɂȂ鍶(endcharEʂ̏ꍇ)
// delim  : delimiter, endcharbrcharꍇ́Aʂ̑Ήl
// dp : et.BufferpointerłȂ΂ȂȂB(buffer𓮓IɊmۂĂ邽)
//      et.Bufferƕʂbuffergpꍇ́Aet.Buffer菬lł邱Ƃۏ؂Ȃ΂ȂȂ
// eva : ̕]s(falseAuser var.j~̂)
tchar *ExpandTemplate1( const tchar *sp, const tchar **nextsp, tchar *dp, ExpTempParam &et, tchar endchar, tchar brchar, tchar delim, bool eva )
{
	int brcount = 0;
//	while ( sp < end ){
	while ( *sp ){
		tuchar c = *sp++;
		tuchar c1;
		if ( c == brchar ){
			brcount++;
			*dp++ = c;
			continue;
		}
		if ( c == endchar ){
			if ( brcount > 0 ){
				brcount--;
				*dp++ = c;
				continue;
			}
			break;
		}
		if ( c == delim ){
			if ( brcount > 0 ){
				*dp++ = c;
				continue;
			}
			break;
		}
		if ( c == '$' ){
			// ϐ //
			c = (tuchar)*sp++;
			switch ( c ){
				case 'c':	// ԍ
					_itot(et.colnum+1, dp, 10);
					break;
				case 'f':
					if (et.len_filename==0) et.len_filename = _tcslen(et.filename);
					ET_REALLOC(dp, et.len_filename);
					_tcscpy(dp, et.filename);
					break;
				case 'l':	// sԍ
					_itot(et.linenum+1, dp, 10);
					break;
				case 'n':
					wsprintf( dp, _T("%ld"), (long)et.num );
					break;
				case 'p':
					if ( et.len_srchstr == 0 ) et.len_srchstr = _tcslen(et.srchstr);
					ET_REALLOC(dp, et.len_srchstr);
					_tcscpy( dp, et.srchstr );
					break;
				case 'u':	// user variable
					c1 = *sp++;
					if ( c1 >= '0' && c1 <= '9' ){
						wsprintf( dp, _T("%d"), et.Var0[c1-'0'] );
					} else
					if ( c1 >= 'A' && c1 <= 'Z' ){
						wsprintf( dp, _T("%d"), et.VarA[c1-'A'] );
					} else
					if ( c1 >= 'a' && c1 <= 'z' ){
						wsprintf( dp, _T("%d"), et.Vara[c1-'a'] );
					} else {
						sp--;
						goto jerr1;
					}
					break;
				case 'V':	// ŌɌvZ
					wsprintf(dp,_T("%d"),et.LastValue);
					dp += _tcslen(dp);
					break;
				case '$':	// ̂
					*dp++ = '$';
					break;
				default:
jerr1:
					*dp++ = *(sp-2);
					*dp++ = *(sp-1);
					goto jmp1;
			}
			dp += _tcslen( dp );
jmp1:;
		} else
		if ( c == '&' && (*(sp+1) == '(' || (*sp=='u' && *(sp+2)=='(') ) ){
			// &()
			c = *sp++;
			tchar *p;
			const tchar *ssp;
			tchar *dp1;
			int value;
			tuchar c1;
			switch ( c ){
				case 'C':	// R[hϊ
					ssp = sp;
					sp++;
					dp1 = ExpandTemplate1( sp, &sp, dp, et, ')', '(', ',', eva );
					if (!dp1){
						return NULL;
					}
					if ( *(sp-1) != ',' ){
						// syntax error : no form
						sp = ssp;
						goto jcan1;
					}
					if (!ExpandTemplate1( sp, &sp, dp1, et, ')', '(', 0, eva )){
						return NULL;
					}
					if ( *(sp-1) != ')' ){
						// syntax error : no end brace
						sp = ssp;
						goto jcan1;
					}
					{
					tnstr src( dp, (int)(dp1-dp) );
					dp = ConvertCharCode(dp1, src, dp, _tcslen(src)*2);	//TODO obt@TCYKII
					if (!dp){
						// not enough memory
						sp = ssp;
						goto jcan1;
					}
					}
					break;
#if 0
				case 'c':	// comment
					if (!ExpandTemplate1( sp, &sp, dp, et, ')', '(', 0, eva )){
						return NULL;
					}
					break;
#endif
				case 'E':	// escape for URI
					ssp = sp;	// cancelp
					sp++;
					if (!ExpandTemplate1( sp, &sp, dp, et, ')', '(', 0, eva )){
						return NULL;
					}
					if ( *(sp-1) == ')' ){
						// dp : WJl
						tnstr s;
						EscapeURIString(dp, s);
						_tcscpy(dp, s);
						dp += _tcslen(dp);
					} else {
						// cancel
						sp = ssp;
						goto jcan1;
					}
					break;
				case 'u':	// user variablȇ
					ssp = sp;
					c1 = *sp++;
					sp++;
					if (!ExpandTemplate1( sp, &sp, dp, et, ')', '(', 0, eva )){
						return NULL;
					}
					if ( *(sp-1) == ')' ){
						// dp : WJ
						if ( eva ){
							if ( EvaluateTemplate( dp, NULL, &value ) ){
								et.LastValue = value;
								if ( c1 >= '0' && c1 <= '9' ){
									et.Var0[c1-'0'] = value;
								} else
								if ( c1 >= 'A' && c1 <= 'Z' ){
									et.VarA[c1-'A'] = value;
								} else
								if ( c1 >= 'a' && c1 <= 'z' ){
									et.Vara[c1-'a'] = value;
								} else {
									sp = ssp;
									goto jcan1;
								}
							} else {
								// LZ
								sp = ssp;
								goto jcan1;
							}
						}
					} else {
						// cancel
						sp = ssp;
						goto jcan1;
					}
					break;
				case 'F':	// t &F(form,val)
					ssp = sp;
					sp++;
					dp1 = ExpandTemplate1( sp, &sp, dp, et, ')', '(', ',', eva );
					if (!dp1){
						return NULL;
					}
					if ( *(sp-1) != ',' ){
						// syntax error : no form
						sp = ssp;
						goto jcan1;
					}
					if (!ExpandTemplate1( sp, &sp, dp1, et, ')', '(', 0, eva )){
						return NULL;
					}
					if ( *(sp-1) != ')' ){
						// syntax error : no end brace
						sp = ssp;
						goto jcan1;
					}
					{
					tnstr form( dp, (int)(dp1-dp) );
					if ( !EvaluateTemplate(dp1,NULL,&value) ){
						sp = ssp;
						goto jcan1;
					}
					wsprintf(dp,form,value);
					dp += _tcslen(dp);
					}
					break;
				case 'N':
					// &N(X) or &N(X,Y)
					ssp = sp;
					sp++;
					{
						static int count=0;
						count++;
						if (count==69){
							printf("");
						}
					}
					dp1 = ExpandTemplate1( sp, &sp, dp, et, ')', '(', ',', eva );
					if (!dp1){
						return NULL;
					}
					{
					tnstr replace_string(_T("\\n"));
					if ( *(sp-1) == ',' ){
						// replacing string
						if (!ExpandTemplate1( sp, &sp, dp1, et, ')', '(', 0, eva )){
							return NULL;
						}
						if ( *(sp-1) != ')' ){
							// syntax error : no end brace
							sp = ssp;
							goto jcan1;
						}
						replace_string = dp1;
					}
					{
						// Replace LF.
						int replace_string_len = replace_string.length();
						tnstr src( dp, (int)(dp1-dp) );
						const tchar *srcp = src;
						for (;;){
							tchar c = *srcp++;
							if (!c){
								*dp = '\0';
								break;
							}
							if (c=='\r'){
								continue;	// Drop CR
							}
							if (c=='\n'){
								_tcscpy(dp, replace_string);
								dp += replace_string_len;
								continue;
							}
							*dp++ = c;	// Normal characters
						}
						
					}
					}
					break;
				case 'V':
					// ̕]
					ssp = sp;	// cancelp
					sp++;
					if (!ExpandTemplate1( sp, &sp, dp, et, ')', '(', 0, eva )){
						return NULL;
					}
					if ( *(sp-1) == ')' ){
						// dp : WJ
						if ( EvaluateTemplate( dp, NULL, &value ) ){
							et.LastValue = value;
							wsprintf(dp,_T("%d"),value);
							dp += _tcslen(dp);
						} else {
							// LZ
							sp = ssp;
							goto jcan1;
						}
					} else {
						// cancel
						sp = ssp;
						goto jcan1;
					}
					break;
				case '?':
					// 
					ssp = sp;	// cancelp
//					tchar *ddp = dp;			// cancelp
					sp++;
					if (!ExpandTemplate1( sp, &sp, dp, et, ')', '(', 0, eva )){
						return NULL;
					}
					if ( *(sp-1) == ')' && *sp == '{' ){
						// dp : WJ
						if ( EvaluateTemplate( dp, NULL, &value ) ){
							p = ExpandTemplate1( sp+1, &sp, dp, et, '}', 0, 0, eva && value );
							if (!p){
								return NULL;
							}
							et.LastValue = value;
							if ( value ){
								// = true
								dp = p;
							} else {
								// = false
							}
							if ( *sp == '?' && *(sp+1) == '{' ){
								p = ExpandTemplate1( sp+2, &sp, dp, et, '}', 0, 0, eva && !value );
								if (!p){
									return NULL;
								}
								if ( !value ){
									dp = p;
								}
							}
						} else {
							// LZ
							sp = ssp;
							goto jcan1;
						}
					} else {
						// cancel
						sp = ssp;
						goto jcan1;
					}
					break;
				default:
			jcan1:
					*dp++ = '&';
					*dp++ = c;
					break;
			}
		} else
		if ( et.escape && c == '\\' ){
			c = *sp++;
			if ( c == 'n' ){
				// escape sequenceɂs
				*dp++ = (tchar)et.crlfchar;
				if ( et.crlfchar == '\r' )
					*dp++ = '\n';
			} else if ( c == 'r' ){
				*dp++ = '\r';
			} else if ( c == 't' ){
				*dp++ = '\t';
			} else {
				*dp++ = *(sp-1);
			}
			ET_REALLOC( dp, 0 );	// 󂫗̈`FbN
		} else
		if ( c == '\r' || c == '\n' ){
			// {̉s
			if ( c == '\r' && *sp == '\n' )
				sp++;
			*dp++ = (tchar)et.crlfchar;
			if ( et.crlfchar == '\r' )
				*dp++ = '\n';
			ET_REALLOC( dp, 0 );	// 󂫗̈`FbN
		} else {
			*dp++ = c;
		}
	}
	*dp = '\0';
	*nextsp = sp;
	return dp;
}
class TStack {
protected:
	int Size;
	void **Stack;
	int Count;
public:
	TStack();
	~TStack();
	void *Peek();
	void *Pop();
	void Push( void * );
	int GetCount()
		{ return Count; }
};
TStack::TStack()
{
	Count = 0;
	Size = 16;
	Stack = new void*[Size];
}
TStack::~TStack()
{
	delete[] Stack;
}
void *TStack::Peek()
{
	if ( Count == 0 ) return NULL;
	return Stack[Count-1];
}
void *TStack::Pop()
{
	if ( Count == 0 ) return NULL;
	return Stack[--Count];
}
void TStack::Push( void *obj )
{
	if ( Count >= Size ){
		void **s = new void*[Size+16];
		memcpy( s, Stack, sizeof(void*)*Size );
		Size += 16;
	}
	Stack[Count++] = obj;
}
struct CalcObj {
	int value;
	char op;	// operator
	char pr;	// priority
	CalcObj( int _value, char _op, char _pr )
		:value( _value ), op( _op ), pr( _pr ){}
};
class TCalcStack : public TStack {
typedef TStack inherited;
public:
	~TCalcStack();
	char GetLastPr();
	bool ExecCalc();
	CalcObj &operator [](int i)
		{ return *(CalcObj*)Stack[i]; }
	CalcObj *Pop()
		{ return (CalcObj*)inherited::Pop(); }
	CalcObj *Peek()
		{ return (CalcObj*)inherited::Peek(); }
	int GetTopValue()
		{ return (*this)[Count-1].value; }
	CalcObj *GetLastObj()
		{ return Count ? (CalcObj*)Stack[Count-1] : NULL; }
};
TCalcStack::~TCalcStack()
{
	for ( int i=0;i<Count;i++ ){
		delete (CalcObj*)Stack[i];
	}
}
char TCalcStack::GetLastPr()
{
	for ( int i=Count-1;i>=0;i--){
		if ( ((CalcObj**)Stack)[i]->op )
			return ((CalcObj**)Stack)[i]->pr;
	}
	return -1;
}
#define	OP_EQUAL	0x40
#define	OP_NOTEQUAL	0x41
#define	OP_GE		0x42
#define	OP_LE		0x43
#define	OP_AND		0x44
#define	OP_OR		0x45
//
// [val1][op][val2]̏ԂƉ
//
// return value:
//	true  : vZ
//  false : vZȂ
bool TCalcStack::ExecCalc( )
{
	if ( Count < 2 ) return false;
	if ( (*this)[Count-1].op ) return false;	// topoperator
	int val2 = (*this)[Count-1].value;
	int val;
	char op = (*this)[Count-2].op;
	// PZq //
	switch ( op ){
		case '!':
			val = !val2;
			break;
		case 0:
			return false;	// syntax error!!
		default:
			goto j1;
	}
	delete Pop();
	delete Pop();
	Push( new CalcObj( val, 0, 0 ) );
	return true;

j1:
	if ( Count < 3 ) return false;
	int val1 = (*this)[Count-3].value;
	op = (*this)[Count-2].op;
	switch ( op ){
		case '+':
			val = val1 + val2;
			break;
		case '-':
			val = val1 - val2;
			break;
		case '*':
			val = val1 * val2;
			break;
		case '/':
			if ( val2 == 0 ){
				val = 0x7FFFFFFF;	//* error
			} else {
				val = val1 / val2;
			}
			break;
		case '%':
			if ( val2 == 0 )
				val = 0;	//* error
			else
				val = val1 % val2;
			break;
		case OP_EQUAL:
			val = (val1 == val2);
			break;
		case OP_NOTEQUAL:
			val = (val1 != val2);
			break;
		case OP_GE:
			val = (val1 >= val2);
			break;
		case OP_LE:
			val = (val1 <= val2);
			break;
		case '<':
			val = (val1 < val2);
			break;
		case '>':
			val = (val1 > val2);
			break;
		case OP_AND:
			val = (val1 && val2);
			break;
		case OP_OR:
			val = (val1 || val2);
			break;
		default:
			return false;
	}
	delete Pop();
	delete Pop();
	delete Pop();
	Push( new CalcObj( val, 0, 0 ) );
	return true;
}
static int _atoi( const tchar *str, const tchar **next )
{
	tuchar c = *str++;
	int val = 0;
	for(;;){
		val = val * 10 + c-'0';
		c = *str;
		if ( c >= '0' && c <= '9' ){
			str++;
			continue;
		}
		break;
	}
	*next = str;
	return val;
}
// I[A')'܂
bool EvaluateTemplate( const tchar *str, const tchar **nextstr, int *value )
{
	int val;
	TCalcStack stack;
	while(*str){
		tuchar c = *str++;
		if ( c == ')' )
			break;
		if ( c >= '0' && c <= '9' ){
			val = _atoi( str-1, &str );
			stack.Push( new CalcObj( val, 0, 0 ) );
		} else {
			char pr;
			switch ( c ){
				case '(':
					{
					int value;
					if ( EvaluateTemplate( str, &str, &value ) ){
						stack.Push( new CalcObj( value, 0, 0 ) );
					} else {
						return false;
					}
					}
					continue;	// top of loop
				case '+':
				case '-':
					if ( *str >= '0' && *str <= '9'
						&&
						(!stack.GetLastObj() || stack.GetLastObj()->op) ){
						// 擪A邢͑OZqłꍇ͕ZqƂĈ
						val = _atoi( str, &str );
						if ( c == '-' ) val = -val;
						stack.Push( new CalcObj( val, 0, 0 ) );
						continue;
					}
					pr = 3;
					break;
				case '*':
				case '/':
				case '%':
					pr = 2;
					break;
				case '=':
					switch ( *str ){
						case '=':
							c = OP_EQUAL;
							break;
						case '!':
							c = OP_NOTEQUAL;
							break;
						case '>':
							c = OP_GE;
							break;
						case '<':
							c = OP_LE;
							break;
						default:	// =
							return false;
//							pr = 5;
//							goto j1;
					}
					str++;
					pr = 4;
//				j1:;
					break;
				case '<':
					if ( *str == '=' ){
						c = OP_LE;
						str++;
					}
					pr = 4;
					break;
				case '>':
					if ( *str == '=' ){
						c = OP_GE;
						str++;
					}
					pr = 4;
					break;
				case '!':
					switch ( *str ){
						case '=':
							str++;
							c = OP_NOTEQUAL;
							break;
						default:
							break;
					}
					pr = 4;
					break;
				case '&':
					switch ( *str ){
						case '&':	// &&
							str++;
							c = OP_AND;
							break;
						default:
							return false;
					}
					pr = 5;
					break;
				case '|':
					switch ( *str ){
						case '|':
							str++;
							c = OP_OR;
							break;
						default:
							return false;
					}
					pr = 5;
					break;
				default:
					return false;
			}
			for(;;){
				char _pr = stack.GetLastPr();
				if ( _pr <= pr ){
					if ( !stack.ExecCalc() ){
						break;
					}
				} else break;
			}
			stack.Push( new CalcObj( 0, c, pr ) );
		}
	}
	while ( stack.GetCount() > 1 ){
		if ( !stack.ExecCalc() ){
			// error?
			return false;
		}
	}
	if ( stack.GetCount() == 0 ){
		// ܂Ȃɂ
		*value = 0;
	} else {
		if ( stack.GetLastObj()->op ){
			// Zq̂ݎc
			return false;
		}
		*value = stack.GetTopValue();
	}
	if ( nextstr )
		*nextstr = str;
	return true;
}
// @return	storeꂽ̍Ō'\0' pointer or NULL(error)
tchar *ConvertCharCode(const tchar *ctype, const tchar *src, tchar *dst, int dstlen)
{
	if (!_tcsicmp(ctype, _T("utf8")) || !_tcsicmp(ctype, _T("utf-8"))){
#ifdef _UNICODE
		int len = _tcslen(src);
		unsigned char *utf8b = new unsigned char[len*4+1];
		if (!utf8b){
			return NULL;
		}
		WideCharToMultiByte(CP_UTF8, 0, src, -1, utf8b, len*4, NULL, NULL);	// UTF16->UTF8
		wchar_t *utf8 = new wchar_t[len*4+1];
		if (!utf8){
			delete[] utf8b;
			return NULL;
		}
		{
			// UTF8QoCgPʂłUTF8ɕϊ
			const unsigned char *sp = utf8b;
			wchar_t *dp = utf8;
			for(;*sp;){
				*dp++ = *sp++;
			}
			*dp = '\0';
		}
		delete[] utf8b;
#else
		int r = MultiByteToWideChar(CP_ACP, 0, src, -1, NULL, 0);
		wchar_t *wbuf = new wchar_t[r+1];
		if (!wbuf)
			return NULL;
		MultiByteToWideChar(CP_ACP, 0, src, -1, wbuf, r);	// SJIS->UTF16
		char *utf8 = new char[r*4+1];
		if (!utf8){
			delete[] wbuf;
			return NULL;
		}
		WideCharToMultiByte(CP_UTF8, 0, wbuf, -1, utf8, r*4, NULL, NULL);	// UTF16->UTF8
		delete[] wbuf;
#endif
		tnstr s;
		EscapeURIString(utf8, s);	// escape utf8 char
		delete[] utf8;
		_tcscpy(dst, s);
		return dst + _tcslen(dst);
	} else {
		_tcscpy(dst, src);
		return dst + _tcslen(dst);
	}
}

