//---------------------------------------------------------------------------

#ifndef FindStrTaskH
#define FindStrTaskH
//---------------------------------------------------------------------------

// Configuration Switch //
#define	USE_SUBTASK		false	// tɒxȂĂ܂HHoO

#include <queue>

#include "ThreadTask.h"
#include "prgstrlib.h"
#include "sem.h"
#include "ffstr.h"
#include "events.h"

#define	FI_FOUND	0x0000
#define	FI_END		0x0001
#define	FI_CANCEL	0x0002
struct TFoundInfo {
	int code;
	const tchar *filename;
	int line;
	int col;
	const tchar *text;
};

typedef int (*FNFoundCallback)(void *obj, void *sender, TFoundInfo &parama);

#define	METHOD_FOUNDCALLBACK(name)	\
	static int name(void *obj, void *sender, TFoundInfo &param); \
	int _##name(void *sender, TFoundInfo &info)

#define	BEGIN_FOUNDCALLBACK(type, name) \
	int type::name(void *obj, void *sender, TFoundInfo &param){ return ((type*)obj)->_##name(sender, param); } \
	int type::_##name(void *sender, TFoundInfo &info)

#define	MAX_FILENAME_QUE	256

class TFindStrTask : public TThreadTask {
typedef TThreadTask super;
protected:
	TFindStrTask *ParentTask;
	TFindStrTask *SubTask;	// own
	bool SubWaiting;
	TEvent *SubWaitEvent;	// own if parent, ref if sub.
	// saved parameters
	int svFindRet;
	int svTimeHash;
	tnstrbuf svFileName;
	// last status
	bool LastCaseIgnHit;

	tnstr Pattern;
	tnstr nPattern;	// normalized pattern
	int nPatternLen;
	int Option;
	tnstr_que FileNames;
	queue<int> TimeHashes;
	FNFoundCallback FoundCallback;
	void *UserData;
	TSem sem;
	_tFindStr *fs;
	_tFindStr *fsi;	// case ignored
public:
	TFindStrTask(bool create_sub=USE_SUBTASK, int quesize=MAX_FILENAME_QUE)
		:FileNames(quesize)
		,sem(0,quesize)
	{
		ParentTask = NULL;
		if (create_sub){
			SubTask = new TFindStrTask(false);
			SubTask->ParentTask = this;
			SubTask->SubWaitEvent = SubWaitEvent = new TEvent;
			SubWaiting = false;
			svFindRet = 0;
		} else {
			SubTask = NULL;
			SubWaitEvent = NULL;
		}
		Option = 0;
		FoundCallback = NULL;
		fs = NULL;
	}
	virtual ~TFindStrTask()
	{
		if (fs)
			delete fs;
		if (SubTask){
			delete SubTask;
			delete SubWaitEvent;
		}
	}
	void Setup(const tchar *pattern, int option, FNFoundCallback callback, void *userdata);
	virtual bool Start();
	virtual void Stop();
	void StopCallback();
	void Done();
	void ReqFile(const tchar *filename, int timehash);
protected:
	// Thread
	virtual void Execute();
	void FindString(const tchar *filename, int timehash);

	// sub task operation
	inline void WaitSubTask()
	{
		SubWaitEvent->Wait();
	}
	inline void WakeParentTask()
	{
		SubWaitEvent->Wake();
	}
};

bool FindStrSaveCache();
bool FindStrLoadCache();
bool FindStrIsCacheModified();

#endif

