//---------------------------------------------------------------------------

#include "tnlib.h"
#pragma hdrstop

#include "MainCmd.h"
#include "SrchProc.h"
#include "prgprofile.h"
#include "pfs.h"
#include "prgcommon.h"
#include "wcommon.h"
#include "ExpTemp.h"
#include "MsgBox.h"
#include "FindStrTask.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

void cmdOpenEditor(TSearchProcI *proc, int index)
{
	if (cmdOpenApp(proc, index, PFS_EDITOR)==-1){
		MsgBox(_t("WinExec error : Set the editor path from Tools - Options"), NULL, MB_OK);
	}
}

void cmdOpenTool(class TSearchProcI *proc, int index)
{
	if (cmdOpenApp(proc, index, PFS_TOOL)==-1){
		MsgBox(_t("WinExec error : Set the tool path from Tools - Options"), NULL, MB_OK);
	}
}

// return
// 0 : no item
// 1 : executed.
// -1: empty app
int cmdOpenApp(class TSearchProcI *proc, int index, const tchar *pfs)
{
	if (index<0)
		return 0;
	tnstr filename;
	int line;
	int col;
	if (proc->GetFile(index, filename, line, col)){
		// open by app
		tnstr cmd = prof.ReadString(PFS_CONFIG, pfs, _t(""));
		if (cmd.empty())
			return -1;

		ExpTempParam et;
		et.temp = cmd;
		et.linenum = line;
		et.colnum = col;
		et.filename = filename;
		et.srchstr = proc->GetPattern();
		ExpandTemplate(et);
		HANDLE h = _WinExec(et.Buffer);
		if (h){
			CloseHandle(h);
			return 1;
		}
	}
	return 0;
}

//Note: do not use when executing a search.
void cmdSaveCache()
{
	if (!FindStrSaveCache()){
		MsgBox(_t("Save error"), NULL, MB_OK);
	}
}

//Note: do not use when executing a search.
void cmdLoadCache()
{
	if (!FindStrLoadCache()){
		MsgBox(_t("Load failed"), NULL, MB_OK);
	}
}

bool cmdIsCacheModified()
{
	return FindStrIsCacheModified();
}

