//---------------------------------------------------------------------------

#ifndef ThreadTaskH
#define ThreadTaskH
//---------------------------------------------------------------------------

#include "defs.h"

class TThreadTask : public TMutex {
protected:
	HANDLE hThread;
	bool SelfDelete;
	bool StopReq;	// Stop requested.
public:
	TThreadTask()
	{
		hThread = NULL;
		SelfDelete = true;
		StopReq = false;
	}
	virtual ~TThreadTask()
	{
		if (hThread)
			CloseHandle(hThread);
	}
	virtual bool Start();
	virtual void Stop();
	void FreeOnTerminate(bool enable)
		{ SelfDelete = enable; }
	int WaitFor();
protected:
	// Thread
	virtual void Execute(){}	// should be overriden
private:
	static DWORD WINAPI ThreadEntry(LPVOID param);
	virtual void _Execute();
};

#endif

