#include	"tnlib.h"
#pragma	hdrstop
#include <stdlib.h>
#include <dirent.h>
#include	"defs.h"
#include	"filestr.h"

#define	FLEN		256	//TODO:

#define	DIR_DELIM	'\\'
#define	DIR_DELIM_S	_t("\\")

inline bool is_delim(const tchar c)
{
	return c=='\\' || c=='/';
}

//path̍Ō'\'ǉ
void addyen(tchar *path)
{
	if (path[0] == '\0')
		return;
	static tchar delim[2] = _T("\\");
	delim[0] = '\\';
	tchar *p = (tchar *)_tcsrchr(path, '\\');
	if ( !p ){
		p = _tcsrchr( path, '/' );
		delim[0] = '/';
	}
	if ( p ){
		if ( p[1] ){
			_tcscat(path, delim );
		}
	} else {
		if (*(path+_tcslen(path)-1) != ':')
			_tcscat(path, _T("\\"));
	}
}

tnstr AddYen(const tchar *path)
{
	if (path[0] == '\0')
		return _t("");

	static tchar delim[2] = _T("\\");
	delim[0] = '\\';
	tnstr ret(path);
	tchar *p = (tchar *)_tcsrchr(path, '\\');
	if ( !p ){
		p = _tcsrchr( path, '/' );
		delim[0] = '/';
	}
	if ( p ){
		if ( p[1] ){
			ret += delim;
		}
	} else {
		if (*(path+_tcslen(path)-1) != ':')
			ret += _t("\\");
	}
	return ret;
}

bool IsLastSlash(const tchar *path)
{
	while (*path) path++;
	return path[-1]=='/' || path[-1]=='\\';
}

// patht@C̐擪̃AhX𓾂
tchar *GetFileName( const tchar *path )
{
	if (!path)
		return NULL;

	const tchar *p;
	const tchar *delim1 = NULL;
	const tchar *delim2 = NULL;

	for ( p=path; *p ; ){
		tchar c = *p;
		if ( c=='\\' || c=='/'){
			delim1 = ++p;
		} else if ( c == ':' ){
			delim2 = ++p;
		} else {
			NEXT_P( p );
		}
	}

	return (tchar*)( delim1 ? delim1 : ( delim2 ? delim2 : path ) );
}
// patht@CP̃pX܂߂擪̃AhX𓾂
tchar *GetFileName1( const tchar *path )
{
	const tchar *p;
	const tchar *delim1 = NULL;
	const tchar *delim2 = NULL;
	const tchar *delim3 = NULL;

	for ( p=path; *p ; ){
		tchar c = *p;
		if ( c=='\\' || c=='/'){
			delim3 = delim1;
			delim1 = ++p;
		} else if ( c == ':' ){
			delim2 = ++p;
		} else {
			NEXT_P( p );
		}
	}

	return (tchar*)( delim3 ? delim3 : (delim1 ? delim1 : ( delim2 ? delim2 : path )) );
}
// gq̈ʒu𓾂
// . ̎̃AhXԂ
// Ȃ NULLԂ
// . ŏIt@CNULLł͂ȂfilenamenullI[̃AhXԂ
tchar *GetFileExtension( const tchar *filename )
{
	const tchar *ext = NULL;
	while ( *filename ){
		if ( *filename == '.' ){
			ext = filename + 1;
		} else if ( *filename == '\\' ){
			ext = NULL;
		}
		NEXT_P( filename );
	}
	return (tchar*)ext;
}
bool IsFullPath( const tchar *filename )
{
#ifdef UNIX
	if ( filename[0] == '/' ){
		return true;
	}
#endif
#ifdef _Windows
	if ( GetFileName( filename ) != filename ){
		if ( filename[1] == ':' || (filename[0] == '\\' && filename[1] == '\\' ) )
		{
			return true;
		}
	}
#endif
	return false;
}

#if !defined(DOS)
//patht@Cxxxxxxxx.xxx`œ
void get_filename( const tchar *path, tchar *filename )
{
#ifdef _Windows
	wsprintf( filename, _T("%-12s"), (LPCTSTR)GetFileName( path ) );
#else
	sprintf( filename, _T("%-12s"), (LPCTSTR)GetFileName( path ) );
#endif
}
#else
//patht@Cxxxxxxxx.xxx`œ
void get_filename( const tchar *path, tchar *filename )
{
	const tchar *p = GetFileName( path );
	int i;
	for ( i=0;i<8;i++ ){
		if ( *p == '.' || *p == '\0' ){
			break;
		}
#ifndef _UNICODE
		if ( _ismbblead( *p ) ){
			if ( i == 7 ){
				while ( *p ){
					if ( *p == '.' )
						break;
					if ( _ismbblead( *p ) )
						p++;
					p++;
				}
				break;
			}
			*filename++ = *p++;
			i++;
		}
#endif
		*filename++ = *p++;
	}
	for ( ;i<8;i++ ){
		*filename++ = ' ';
	}
	i = 0;
	if ( *p == '.' ){
		*filename++ = '.';
		p++;
		for ( ;i<3;i++ ){
			if ( *p == '\0' )
				break;
#ifndef _UNICODE
			if ( _ismbblead( *p ) ){
				if ( i == 2 ){
					break;
				}
				*filename++ = *p++;
				i++;
			}
#endif
			*filename++ = *p++;
		}
	}
	for ( ;i<3;i++ ){
		*filename++ = ' ';
	}
	*filename = '\0';
}
#endif

// őmaxlen܂ł̃t@C쐬
//	maxlen > 20 ȏł邱
//	Ԃl͍쐬ꂽt@C
const tchar *MakeShortFilename( const tchar *name, int maxlen )
{
	static tchar *buf = NULL;
	if ( buf )
		delete[] buf;

	if ( _tcslen( name ) <= (unsigned)maxlen ){
		buf = newstr( name );
		return buf;
	}

	buf = new tchar[ maxlen + 1 ];

	tchar *dp = buf;
	const tchar *sp = name;
	if ( name[1] == ':' ){
		// hCuꍇ
		*dp++ = *sp++;
		*dp++ = *sp++;
		maxlen -= 2;
	}
	const tchar *base = GetBaseName( name );
	int baselen = _tcslen( base );
	maxlen -= 3;	// ..\<basename>..\̒̕
	int _maxlen = maxlen - baselen;
	if ( _maxlen < 0 ) _maxlen = 0;
#ifdef WIN32
	while ( sp < base ){
#else
	while ( FP_OFF( sp ) < FP_OFF( base ) ){
#endif
		const tchar *yp = sp;
		while ( *yp ){
			if ( *yp == '\\' ){
				break;
			}
			yp = GetNextPtr( yp );
		}
		if ( *yp ){
			yp++;
			int l = STR_DIFF( yp, sp );
			if ( l < _maxlen ){
				_tcsncpy( dp, sp, l );
				dp += l;
				_maxlen -= l;
				sp = yp;
			} else {
				break;
			}
		} else {
			// Zks\
			_tcscpy( buf, _T("?") );
			return buf;
		}
	}
	_tcscpy( dp, _T("..\\") );
	dp += 3;
#ifdef WIN32
	if ( maxlen < baselen ){
		memcpy( dp, base, maxlen-3 );
		dp[maxlen-3] = '.';
		dp[maxlen-2] = '.';
		dp[maxlen-1] = '.';
		dp[maxlen] = '\0';
	} else
#endif
	{
		_tcscpy( dp, base );
	}
	return buf;
}

// tfile1  tfile2 ̔r
//	A񂪂ȂAsȃt@CfalseԂB
//	SɈvꍇ̂trueԂ
//Note:
//	pXȂƃJgfBNgtĔr̂ŗvӁI
//	ȂׂIsSameFileName()gp邱ƁIII
bool IsSameFile( const tchar *name1, const tchar *name2 )
{
	tnstr n1;
	tnstr n2;
	makename( n1, name1, NULL );
	makename( n2, name2, NULL );
	if ( _tmbsicmp( n1, n2 ) == 0 ){
		return true;
	}
	return false;
}

// namename2r
// Płt@CƁAtrueԂ
bool IsSameFile( tnstr_vec &name1, const tchar *name2 )
{
	for ( int i=0;i<name1.get_num();i++ ){
		if ( IsSameFile( name1[i], name2 ) )
			return true;
	}
	return false;
}

bool IsSameFileName(const tchar *file1, const tchar *file2)
{
	return _tmbsicmp(file1, file2) == 0;
}

bool HasFilePath(const tchar *filename)
{
	return filename != GetFileName(filename);
}

// path1path2猩relative driveɕύX
tnstr MakeRelativeDrive(const tchar *path1, const tchar *path2)
{
	const tchar *drive_end = _tcsstr(path2, _t(":"));
	if (!drive_end){
		// no drive??
		// use as is.
		return path1;
	}
	drive_end++;
	int len = STR_DIFF(drive_end, path2);
	if (_tcsnicmp(path1, path2, len)){
		// not same drive.
		return path1;
	}
	// same drive
	return tnstr(path1+len);
}

// [path1drive]+path2쐬
// path2̐擪\ꍇ͒ǉ
// path2ɂłdriveꍇpath2̂܂ܕԂ
// path1driveꍇpath2̂܂ܕԂ(v)
tnstr MakeAbsoluteDrive(const tchar *path1, const tchar *path2)
{
	const tchar *drive_end = _tcsstr(path2, _t(":"));
	if (drive_end){
		// drive includes
		return path2;
	}
	drive_end = _tcsstr(path1, _t(":"));
	if (!drive_end){
		// no drive
		return path2;
	}
	drive_end++;
	int len = STR_DIFF(drive_end, path1);
	tnstr ret(path1, len);
	if (path2[0]!='\\' && path2[0]!='/'){
		ret += DIR_DELIM_S;
	}
	return ret+path2;
}

// path1path2猩relative pathɕύX
// path2ƊSɈv镔path1ɂꍇpath1-path2ԂB
// ȊÓA
// inc_drive=true:
//	return MakeRelativePath + MakeRelativeDrive
// inc_drive=false:
//	return NULL
tnstr MakeRelativePath(const tchar *path1, const tchar *path2, bool inc_drive)
{
	const tchar *p1 = path1;
	const tchar *p2 = path2;
	static const tchar *delims = _t(":\\/");
	for (;*p1&&*p2;){
		size_t s1 = _tcscspn(p1, delims);
		const tchar *q1 = p1+s1;
		size_t s2 = _tcscspn(p2, delims);
		const tchar *q2 = p2+s2;
		int len1 = STR_DIFF(q1, p1);
		int len2 = STR_DIFF(q2, p2);
		if (len1!=len2)
			break;	// not matched length
		if (_tcsnicmp(p1, p2, len1)){
			// not same
			break;
		}
		p1 = q1;
		p2 = q2;
		if (!*p2){
			break;	// partly matched. (path1 + ... = path2)
		}
		p1++;
		p2++;
	}

	if (!*p2){	// complete match
		while (is_delim(*p1)) p1++;	// skip delimitor not to be a root directory.
		return tnstr(p1);
	}

	if (!inc_drive)
		return NULL;
	return MakeRelativeDrive(path1, path2);
}

tnstr MakeAbsolutePath(const tchar *path1, const tchar *path2)
{
	if (is_delim(path2[0]) && !is_delim(path2[1])){
		// only root directory
		return MakeAbsoluteDrive(path1, path2);
	}
	if (IsFullPath(path2)){
		return path2;
	}
	tnstr ret(AddYen(path1));
	return ret + path2;
}

// obsolete
// filename̊gqextɕύX
void ChangeFileExtension( tnstr &filename, const tchar *ext )
{
	tchar *p = GetFileExtension( filename );
	if ( p ){
		p[0] = '\0';
		filename.cat( ext );
	} else {
		filename.cat( _T(".") );
		filename.cat( ext );
	}
}

// filename̊gqextɕύX
tnstr ChangeFileExt( const tchar *filename, const tchar *ext )
{
	tnstr ret(filename);
	tchar *p = GetFileExtension( ret );
	if ( p ){
		p[0] = '\0';
		if (ext && ext[0]){
			ret += ext;
		} else {
			p[-1] = '\0';
		}
	} else {
		if (ext && ext[0]){
			ret += _t(".");
			ret += ext;
		}
	}
	return ret;
}

// filenamepathnewpathpathɕύX
// newpath́At@C܂܂ĂĂOK.
// newpathɃt@CꍇAŌ \ Kv
// newpatht@Ĉ݂̂Ƃ͕ύXȂ
void ChangePath( tnstr &newfilename, const tchar *filename, const tchar *newpath )
{
	const tchar *fn = GetFileName( newpath );
	if ( fn == newpath )
		return;
	newfilename.set( newpath, STR_DIFF(fn,newpath) );
	newfilename.cat( GetFileName( filename ) );
}

// Ō \ tpathԂ
// t@Cpathꍇ́A""Ԃ(\͂Ȃ)
tnstr _GetFilePath( const tchar *filename )
{
	const tchar *lp = GetFileName( filename );
	return tnstr(filename, STR_DIFF(lp,filename));
}

tnstr GetTempPath()
{
	TCHAR buf[MAX_PATH+1];
	buf[0] = '\0';
	GetTempPath(MAX_PATH, buf);
	return tnstr(buf);
}

// pathfilename
// path̍Ō'\'ꍇ͕t
// filenamepath݂ꍇfilenamê܂ܕԂ 2008.4.14
tnstr MakePath(const tchar *path, const tchar *filename)
{
	if (!path || !path[0] || filename!=GetFileName(filename)){
		return tnstr(filename);
	}
	const tchar *p = path;
	const tchar *last = NULL;
	for (;*p;){
		if (*p=='\\'||*p=='/'){
			last = p;
		} else {
			last = NULL;
		}
		p = CharNext(p);
	}
	if (!last){
		return tnstr(path) + _t("\\") + filename;
	}
	return tnstr(path) + filename;
}

bool MkDir(const tchar *dir)
{
	const tchar *p = dir;
	for (;;){
		if (*p=='/' || *p=='\\' || !*p){
			// separator
			tnstr path(dir, STR_DIFF(p,dir));
			if (!fexist(path)){
				if (_tmkdir(path)!=0){
					return false;	// error
				}
			}
			if (!*p)
				break;
		}
		p = CharNext(p);
	}
	return true;
}

bool is_dir(const tchar *path)
{
	DWORD dwAttr = ::GetFileAttributes(path);
	if (dwAttr == 0xFFFFFFFFu)
		return false;	// error
	return (dwAttr & FILE_ATTRIBUTE_DIRECTORY) ? true : false;
}

int ReadDir(tnstr_vec &files, const tchar *dir, const tchar *ext)
{
	_tDIR *d = _topendir( dir );
	if (!d)
		return 0;
	struct _tdirent *ent;
	while ((ent = _treaddir(d)) != NULL){
		tnstr path(AddYen(dir));
		path += ent->d_name;
		if (is_dir(path)){
			// directory
			continue;
		}
		if (ext){
			tchar *cext = GetFileExtension(ent->d_name);
			if (!cext || !IsSameFileName(ext,cext)){
				continue;
			}
		}
		files.push(ent->d_name);
	}
	_tclosedir( d );
	return files.size();
}

bool strmatch(const tchar *str, const tchar *mask)
{
	switch( *mask ){
		case '\0':
			return !*str;
		case '*':
			return strmatch(str, mask+1)
				|| (*str && strmatch(str+1, mask));
		case '?':
			return *str && strmatch(str+1, mask+1);
		default:
			return (*str==*mask) && strmatch(str+1, mask+1);
	}
}

// filename΃pX̏ꍇAJgfBNg̃pXɕϊB(path͎gpȂ)
// ꂪsւȏꍇmakefile2()gpB
//path+filename -> fullpath (FLENj
// filenameɃpX΂𗘗pA΃pX̏ꍇ̓JgfBNgfullpathɕϊ
// filenameɃpXpath𗘗p
// filenameNULLɂƑ΃pXpath΃pXɕϊ̂݁iJgfBNgĝŗvӁIIj
bool makename( tnstr &fullpath, const tchar *path, const tchar *filename )
{
	if ( filename ){
		const tchar *base = GetFileName( filename );
		if (base != filename){
			// including path in filename
			tchar *p = _tfullpath( NULL, filename, FLEN );
			if ( p ){
				fullpath.set( p );
				free( p );
				return true;
			}
			return false;
		}
	}
	if ( !path || !path[0] )
		return false;	// parameter error 
	tchar *p = new tchar[ max((unsigned int)MAX_PATH,_tcslen(path)) + 1 ];
	if (!p)
		return false;	// memory error
	_tcscpy( p, path );
	if ( filename ){
		addyen( p );
		_tcscat( p, filename );
	}
	tchar *q = _tfullpath( NULL, p, FLEN );
	delete[] p;
	if ( q ){
		fullpath.set( q );
		free( q );
		return true;
	}
	return false;
}

