//---------------------------------------------------------------------------

#include "tnlib.h"
#pragma hdrstop

#include "prgcommon.h"
#include "filestr.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

tnstr ModuleFileName;
tnstr CommandPath;

static HWND hwndMain = NULL;
static WORD LangId = 0;

void PrgInit(HINSTANCE hInstance, HWND hwnd)
{
	tchar modulename[ MAXPATH ];
	::GetModuleFileName( hInstance, modulename, MAXPATH );
	ModuleFileName = modulename;
	CommandPath = _GetFilePath(ModuleFileName);

	hwndMain = hwnd;
}

// window(hwnd)hwndParentcenterֈړ
// screen̊O֏oꍇ͒
void MoveCenter( HWND hwnd, HWND hwndParent )
{
	RECT rc;
	RECT rd;
	if (!hwndParent){
		hwndParent = hwndMain;	// parentȂmain window
	}
	if (hwndParent){
#ifndef WINCE
		if ( IsIconic(hwndParent) ){
			GetScreenSize(hwndParent, &rc);
		} else
#endif
		{
			::GetWindowRect( hwndParent, &rc );
		}
	} else {
		GetScreenSize(hwnd, &rc);
	}
	RECT rcScr;
	GetScreenSize(hwnd, &rcScr);
	::GetWindowRect( hwnd, &rd );
	int width = rd.right - rd.left;
	int height = rd.bottom - rd.top;
	int left = rc.left + ( ( rc.right - rc.left ) - width )/2;
	int top = rc.top + ( ( rc.bottom - rc.top ) - height )/2;
	if ( left < rcScr.left ){
		left = rcScr.left;
	}
	if ( top < rcScr.top ){
		top = rcScr.top;
	}
	if ( left + width > rcScr.right ){
		left = rcScr.right - (rd.right - rd.left);
	}
	if ( top + height > rcScr.bottom ){
		top = rcScr.bottom - (rd.bottom - rd.top);
	}
	::SetWindowPos( hwnd, (HWND)NULL, left & ~7, top, 0, 0, SWP_NOSIZE | SWP_NOZORDER );
}

void GetScreenSize(HWND hwndBase, RECT *rcWork, RECT *rcScreen)
{
#if 0
	if (!PdicMain){
		__assert(false);
		MLFXPC_CMN_ASSERT(false);
		if (rcScreen){
			SetRect(rcScreen, 0, 0, GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN));
		}
		if (rcWork){
			SystemParametersInfo(SPI_GETWORKAREA, 0, rcWork, 0);
		}
		return;
	}
#endif
	//__assert(hwndMain!=NULL);
	HMONITOR hMonitor = MonitorFromWindow(hwndBase ? hwndBase : (hwndMain ? hwndMain : GetActiveWindow()), MONITOR_DEFAULTTONEAREST);
	__assert(hMonitor!=NULL);
	MONITORINFO mi;
	memset(&mi, 0, sizeof(mi));
	mi.cbSize = sizeof(mi);
	GetMonitorInfo(hMonitor, &mi);
	if (rcScreen){
		*rcScreen = mi.rcMonitor;
	}
	if (rcWork){
		*rcWork = mi.rcWork;
	}
}

///////////////////////////////////////////////////////////////
// MessageBox
///////////////////////////////////////////////////////////////
static void SetMsgBox(HWND hwnd);
// CӂwindoweEChEƂĕ\
// NULL̏ꍇmain window
// -1̏ꍇdesktop
int MsgBox(HWND hwnd, LPCTSTR text, LPCTSTR caption, UINT type)
{
	if (!hwnd){
		hwnd = hwndMain;
		if (!hwnd){
			hwnd = GetActiveWindow();
		}
	}
	if (hwnd){
		if (hwnd==(HWND)-1){
			hwnd = NULL;	// desktop window
		} else {
			SetMsgBox(hwnd);
		}
	}
	return ::MessageBoxEx(hwnd, text, caption, type, LangId);
}
// activewindoweEChEƂĕ\
int MsgBox(LPCTSTR text, LPCTSTR caption, UINT type)
{
	HWND hwnd = GetActiveWindow();
	return ::MsgBox(hwnd, text, caption, type);
}

// MessageBox hwndParent̒Sɕ\邽߂̏
static HHOOK hHook;
static HWND hwndParent;
static LRESULT CALLBACK CBTProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	if (nCode == HCBT_ACTIVATE){
		HWND hwndMsgBox = (HWND)wParam;
		RECT rcMsgBox;
		RECT rcParent;
		GetWindowRect(hwndMsgBox, &rcMsgBox);
		GetWindowRect(hwndParent, &rcParent);
		int x = rcParent.left + (rcParent.right-rcParent.left)/2 - (rcMsgBox.right-rcMsgBox.left)/2;
		int y = rcParent.top + (rcParent.bottom-rcParent.top)/2 - (rcMsgBox.bottom-rcMsgBox.top)/2;
		SetWindowPos(hwndMsgBox, 0, x, y, 0, 0, SWP_NOSIZE|SWP_NOZORDER|SWP_NOACTIVATE);
		UnhookWindowsHookEx(hHook);
	}
	return 0;
}
static void SetMsgBox(HWND hwnd)
{
	hwndParent = hwnd;
	hHook = SetWindowsHookEx(WH_CBT, CBTProc, hTNInstance, GetCurrentThreadId());
}

