//---------------------------------------------------------------------------

#include "tnlib.h"
#pragma hdrstop

#include "prgstrlib.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

tnstr_que::tnstr_que(int _maxnum)
	:maxnum(_maxnum)
{
	data = new tnstr*[maxnum];
	num = 0;
	in_index = out_index = 0;
}
tnstr_que::~tnstr_que()
{
	clear();
	if (data){
		delete[] data;
	}
}
void tnstr_que::clear()
{
	while (num>0){
		if (data[out_index]){
			delete data[out_index++];
			if (out_index>=maxnum)
				out_index = 0;
		}
		num--;
	}
}
bool tnstr_que::push(tnstr *s)
{
	if (num>=maxnum)
		return false;
	data[in_index++] = s;
	if (in_index>=maxnum)
		in_index = 0;
	num++;
	return true;
}

// helper
bool tnstr_que::push(const tchar *s)
{
	if (num>=maxnum)
		return false;
	return push(new tnstr(s));
}

tnstr *tnstr_que::pop()
{
	if (num==0)
		return NULL;
	tnstr *r = data[out_index++];
	if (out_index>=maxnum)
		out_index = 0;
	num--;
	return r;
}


// URIescapeȂ΂ȂȂflag, etc..
static char uriescape[] = {
	// 0x20
	1, 0, 1, 1, 1, 1, 1, 0,
	0, 0, 0, 1, 1, 0, 0, 1,
	// 0x30
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 1, 1, 1, 1, 1, 1,
	// 0x40
	1, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	// 0x50
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 1, 1, 1, 1, 0,
	// 0x60
	1, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	// 0x70
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 1, 1, 1, 0, 1
};
// %xxɕϊ
void EscapeURIString( const tchar *str1, tnstr &str2 )
{
	tchar *buf = new tchar[ _tcslen(str1) * 3 + 1 ];
	tchar *dp = buf;
	for(;;){
		tuchar c = (tuchar)*str1++;
		if (!c)
			break;
		if (c>=0x20 && c<=0x7F){
			if (uriescape[c-0x20]&1){
				// escape char
			} else {
				*dp++ = c;
				continue;
			}
		}
		*dp++ = '%';
		*dp++ = (c>>4)>=0xA ? (c>>4)+'A'-0xA : (c>>4) + '0';
		*dp++ = (c&0xF)>=0xA ? (c&0xF)+'A'-0xA : (c&0xF) + '0';
	}
	*dp = '\0';
	str2.setBuf( buf );
}

void LowerToUpper( tchar *str )
{
	if ( str[0] >= 'A' && str[0] <= 'Z' ){
		CharUpper( str );
	} else {
		str[0] = (tchar)CharUpper( (LPTSTR)MAKELONG( (tuchar)str[0], 0 ) );
	}
}

/*======================================================================//
//	itocs()
//----------------------------------------------------------------------//
// Description:
//	unsigned l10i(RJ}t
//	textɃobt@AhX
//	߂l͕ϊꂽ̐擪̈ʒu
//	obt@20oCgȏł邱
// Arguments:
//
// Return Value:
//	Rs[̐擪AhX
//======================================================================*/
tchar *itocs( int val, tchar *text )
{
	int c = 0;
	text += 19;
	*text-- = '\0';
	bool sign;
	if (val<0){
		sign = true;
		val = -val;
	} else {
		sign = false;
	}
	while ( val != 0 ){
		if ( (c % 3 == 0) && c != 0 ){
			*text-- = ',';
		}
		*text = (tchar)((val % 10)+'0');
		val = val / 10;
		text--;
		c++;
	}
	if ( c == 0 ) *text-- = '0';
	else if (sign) *text-- = '-';
	return text+1;
}
//---------------------------------------------------------------------------
tnstr itocs(int val)
{
	tchar buf[20];
	return itocs(val, buf);
}

// text should be more than 40 bytes.
tchar *itocs64(__int64 val, tchar *text)
{
	int c = 0;
//	tchar *text = buf+tsizeof(buf)-1;
	text += 39;
	*text-- = '\0';
	while ( val != 0 ){
		if ( (c % 3 == 0) && c != 0 ){
			*text-- = ',';
		}
		*text = (tchar)((val % 10)+'0');
		val /= 10;
		text--;
		c++;
	}
	if ( c == 0 ) *text-- = '0';
	return text+1;
}
tnstr itocs64(__int64 val)
{
	tchar buf[40];
	return itocs64(val, buf);
}

