//---------------------------------------------------------------------------

#ifndef semH
#define semH
//---------------------------------------------------------------------------

class TSem {
protected:
	HANDLE hSem;
public:
	TSem(int initial_count=1, int max_count=1)
	{
		hSem = CreateSemaphore( NULL, initial_count, max_count, NULL );
	}
	virtual ~TSem()
	{
		CloseHandle(hSem);
	}
	// thread safe
	bool Wait(int timeout=INFINITE)
	{
		return WaitForSingleObject( hSem, timeout ) == WAIT_OBJECT_0;
	}
	// thread safe
	void Release()
	{
		if (!ReleaseSemaphore( hSem, 1, NULL )){
			DBW("ReleaseSemphare:%08X", GetLastError());
		}
	}
};

#endif
