//---------------------------------------------------------------------------

#include "tnlib.h"
#pragma hdrstop

#include "wcommon.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

const tchar *MyWinTitle = _T("<Processing...>");

HANDLE _WinExec( const tchar *cmd, int show, const tchar *dir )
{
#ifdef WINCE
	PROCESS_INFORMATION pi;
	if ( !CreateProcess( NULL, (LPTSTR)cmd, NULL, NULL, FALSE, 0, NULL, NULL, NULL, &pi ) )
		return NULL;
	return pi.hProcess;
#else
	STARTUPINFO sui;
	memset( &sui, 0, sizeof(STARTUPINFO) );
	sui.cb = sizeof(STARTUPINFO);
	sui.dwFlags = STARTF_USESHOWWINDOW;
	sui.wShowWindow = (WORD)show;
	sui.lpTitle = (LPTSTR)MyWinTitle;
	PROCESS_INFORMATION pi;
	if ( !CreateProcess( NULL, (LPTSTR)cmd, NULL, NULL, FALSE, NORMAL_PRIORITY_CLASS, NULL, dir, &sui, &pi ) )
		return NULL;
	return pi.hProcess;
#endif
}


///////////////////////////////////////////////////////////////
// Nbv{[h
///////////////////////////////////////////////////////////////
// len͏I[NULL܂܂Ȃ
bool CopyClipboard( HWND hwnd, const tchar *txt, uint len )
{
	if ( !OpenClipboard( hwnd ) ){
		// Nbv{[hI[vłȂ
		return false;
	}

	if (!EmptyClipboard( )){
		CloseClipboard();
		return false;
	}

	bool ret = CopyClipboard( txt, len );

	CloseClipboard( );

	return ret;
}
bool CopyClipboard( const tchar *txt, uint len )
{
	if (len==(UINT)-1){
		len = _tcslen(txt);
	}

	HGLOBAL hmem = GlobalAlloc( GMEM_MOVEABLE|GMEM_DDESHARE, LENTOBYTE(len+1) );
	if ( !hmem ) return false;
	LPTSTR lpmem = (LPTSTR)GlobalLock( hmem );
	if ( !lpmem ){
		GlobalFree( hmem );
		return false;
	}
	memcpy( lpmem, txt, (UINT)LENTOBYTE(len) );
	lpmem[ len ] = '\0';
	GlobalUnlock( hmem );
	return SetClipboardData( CF_TTEXT, hmem )!=NULL;
}
bool IsClipboardText()
{
	return IsClipboardFormatAvailable(CF_TTEXT);
}
tnstr GetClipboardText(HWND hwnd)
{
	if (!OpenClipboard(hwnd))
		return NULL;
	tnstr ret;
	HANDLE h = GetClipboardData(CF_TTEXT);
	if (h){
		LPTSTR lpmem = (LPTSTR)GlobalLock(h);
		if (lpmem){
			ret.set((const tchar*)lpmem, GlobalSize(h)/sizeof(tchar));
			GlobalUnlock(h);
		}
	}
	CloseClipboard();
	return ret;
}
// do not terminated with '\\'
bool DeleteFiles(const tchar *path)
{
	int len = _tcslen(path);
	tnstrbuf buf(path, len+2);
	buf[len+1] = '\0';	// double terminator

	SHFILEOPSTRUCT op;
	memset(&op, 0, sizeof(op));
	op.wFunc = FO_DELETE;
	op.pFrom = buf;
	op.fFlags = FOF_SILENT|FOF_NOCONFIRMATION|FOF_NOERRORUI;
	return SHFileOperation(&op)==0;
}


