//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include "tnlib.h"
#include "vclcom.h"

#include "SquFrm.h"
#include "SquIF.h"
#include "SquViewFrm.h"
#include "Squ.h"
#include "SquUIMain.h"

#include "prgprofile.h"
#include "pfs.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "TntComCtrls"
#pragma resource "*.dfm"

#define	MAX_TABS	16	// ő^u

TSquFrame *SquFrame;
//---------------------------------------------------------------------------
__fastcall TSquFrame::TSquFrame(TComponent* Owner, TSquUIMain *main)
	: TTntFrame(Owner)
{
	TWinControl *win = (TWinControl*)Owner;
	Parent = win;

	UIMain = main;
	Active = NULL;

	// Tab control //
	UniqFrameNumber = 0;
	TabVisible = true;
}
//---------------------------------------------------------------------------
TSqu *TSquFrame::GetActiveS()
{
	if (!Active)
		return NULL;
	return Active->GetSquare();
}

bool TSquFrame::SetActive(TTabSheet *active)
{
	if (!active->Tag)
		return false;	// The tab sheet does not know the SquView.
	foreach_square(squ){
		if ((int)squ->GetView() == active->Tag){
			if (Active!=squ){
				ChangeActive(squ);
				NotifyTabChanged();
			}
			return true;
		}
	}
	return false;	// Not found the SquInterface in the Squares vector.
}
void TSquFrame::ChangeActive(TSquIF *obj)
{
	if (Active!=obj){
		if (Active)
			Active->GetSquare()->_Deactivate();
		Active = obj;
		if (Active)
			Active->GetSquare()->Activate();
	}
}
bool TSquFrame::_CanClose(bool withmsg)
{
	foreach_square(squ){
		if (!squ->CanClose(withmsg)){
			return false;
		}
	}
	return true;
}
// GUI //
void TSquFrame::Setup()
{
}
void TSquFrame::Cleanup()
{
	SaveTabs();
	foreach_square(squ){
		squ->Close();
	}
	ChangeActive(NULL);
}
void TSquFrame::ResetFont()
{
	foreach_square(squ){
		squ->ResetFont();
		squ->ResetColor();
	}
}
void TSquFrame::ResetColor()
{
	foreach_square(squ){
		squ->ResetColor();
	}
}
void TSquFrame::EvActivate(bool active)
{
	TSquIF *squif = GetActive();
	if (!squif)
		return;
	squif->EvActivate(active);
}
// Tab operations //
bool TSquFrame::NewTab()
{
	if (GetTabCount()>=MAX_TABS)
		return false;

	UniqFrameNumber++;
	tnstr name = tnsprintf(_t("Page%d"), UniqFrameNumber);

	TTntTabSheet *newtab = new TTntTabSheet(SquareTab);
	newtab->Parent = SquareTab;
	newtab->PageControl = SquareTab;
	newtab->TabVisible = TabVisible;
	newtab->Caption = tnsprintf(_t("%d"), UniqFrameNumber);

	//TODO: ݊JẴׂ^uɒǉ̂TPageControl͕s\H

	TSquViewFrame *view = new TSquViewFrame(SquareTab, UIMain);	//TODO: ownernewtabł͂Ȃ̂H
	view->Name = TtoWString(name);
	TSquIF *squi = new TSquIF(this, view, UIMain);
	view->SetInterface(squi);
	view->Parent = newtab;	// Parent̎wԈႦ(SquareTab)ɂƐɓ삵Ȃ̂Œ
	newtab->Tag = (int)view;

	// Change the active tab.
	SquareTab->ActivePage = newtab;
	Squares.add(squi);

	ChangeTabVisible();

	//squi->SetHWindow(view->Handle);
	squi->LoadProfile();
	squi->Setup();
	ChangeActive(squi);
	NotifyTabChanged();
	return true;
}
void TSquFrame::CloseTab()
{
	if (Squares.get_num()<=1){
		//TODO: message
		return;	// Cannot delete the last one.
	}
	TSquIF *squi = GetActive();
	if (!squi->CanClose(true))
		return;
	squi->Close();

	// delete,SelectNextPage()Activeω邽߂ňꎞۑ
	TSquIF *delActive = Active;

	delete SquareTab->ActivePage;		// delete TabContorl
	SquareTab->SelectNextPage(false);

	// Delete TSquIF from Squares //
	foreach_square(squ){
		if (delActive == squ){
			Squares.del(i);
			break;
		}
	}

	Active = NULL;
	SetActive(SquareTab->ActivePage);
	ChangeTabVisible();
}

void TSquFrame::PrevTab()
{
	SquareTab->SelectNextPage(false);
}
void TSquFrame::NextTab()
{
	SquareTab->SelectNextPage(true);
}
void TSquFrame::NotifyTabChanged()
{
	UIMain->NotifyTabChanged();
}
void TSquFrame::SetTabName(const tchar *name)
{
	if (!SquareTab->ActivePage)
		return;
	SquareTab->ActivePage->Caption = name;
}

#if 0
int TSquFrame::FindTab(const tchar *name)
{
	for (int i=0;i<SquareTab->PageCount;i++){
		if (!_tcscmp(SquareTab->Pages[i]->Name, name)){
			return i;
		}
	}
	return -1;
}
#endif
int TSquFrame::GetTabCount()
{
	return SquareTab->PageCount;
}
void TSquFrame::SelectTab(int no)
{
	if (no<0 || no>=SquareTab->PageCount)
		return;
	SquareTab->ActivePage = SquareTab->Pages[no];
	SetActive(SquareTab->ActivePage);	// to notify.
}

// ݂ActivePagenew_indexֈړ
void TSquFrame::MoveActiveTab(int new_index)
{
	if (SquareTab->ActivePage->PageIndex==new_index)
		return;

	// exchange squ_if
	TSquIF *squ = Squares.discard(SquareTab->ActivePage->PageIndex);
	Squares.insert(new_index, squ);
	SquareTab->ActivePage->PageIndex = new_index;
	SaveTabs();
}

void TSquFrame::SetTabVisible(bool visible)
{
	TabVisible = visible;
	for (int i=0;i<SquareTab->PageCount;i++){
		SquareTab->Pages[i]->TabVisible = visible;
	}
}

void TSquFrame::SaveTabs()
{
	tnstr tabs;
#if 0	// build tab name
	foreach_square(squ){
		DicGroup &dg = squ->GetDicGroup();
		//__assert(dicgrp.size()==0||dg.name.exist());
		if (dg.name.empty())
			continue;
		if (tabs.exist())
			tabs += _t("\t");
		tabs += dg.name;
	}
#endif

	prof.SetSection(PFS_COMMON);
	prof.WriteString(PFS_TABNAMES, tabs);
	prof.WriteInteger(PFS_ACTIVETAB, SquareTab->ActivePage->PageIndex);
}

// RestoreActiveTab()Ă΂Ȃactive tablast tab̂܂
void TSquFrame::RestoreTabs()
{
	prof.SetSection(PFS_COMMON);

	int act_index = prof.ReadInteger(PFS_ACTIVETAB, 0);
	int org_act_index = act_index;

	tnstr_vec tabs;
	tabs.split(prof.ReadString(PFS_TABNAMES, _t("")), _t("\t"));
//	int i=0;
	foreach_tnstr_vec(tabs, tab){
#if 0
		int index = dicgrp.Find(tab->c_str());
		if (index<0){
			if (act_index>=i)
				act_index--;
			continue;	// ignore
		}
#endif

		if (!NewTab())
			break;	// over limit
//		Active->SetDicGroup(dicgrp[index]);
		SetTabName(tab->c_str());
//		i++;
	}
	if (act_index!=org_act_index)
		prof.WriteInteger(PFS_ACTIVETAB, act_index);
}

void TSquFrame::RestoreActiveTab()
{
	prof.SetSection(PFS_COMMON);
	int act_index = prof.ReadInteger(PFS_ACTIVETAB, 0);
	SelectTab(act_index);
}

// tabP̎tab
void TSquFrame::ChangeTabVisible()
{
#if 0	// oOł
	// Tab visible
	//Note:
	// new TTntTabSheet()̑OōsĂ͂ȂBi炭tabȂꍇƎv)
	// ƁAwinsqu̍ĕ`揈ɂȂB
	// VCL̃oOH
	if (SquareTab->PageCount<=1){
		SquareTab->TabHeight = 1;
		SquareTab->TabWidth = 1;
	} else {
		SquareTab->TabHeight = 0;
		SquareTab->TabWidth = 0;
	}
#endif
}

// Message //
//Note:
// UIMain->message()𒼐ڌĂ΂ɂ𗘗p
void TSquFrame::SetMsg(TSquIF *sender, const tchar *msg, int pasttime, int count)
{
	if (sender==Active){
		UIMain->SetMsg(sender, msg, pasttime, count);
	}
}
#if 0
void TSquFrame::SetMsg(TSqu *sender, const tchar *msg, int pasttime, int count)
{
	if (sender==GetActiveS()){
		UIMain->SetMsg(sender, msg, pasttime, count);
	}
}
#endif

#if 0
//---------------------------------------------------------------------------
//	Event Handlers
//---------------------------------------------------------------------------
void TSquFrame::EvUpdate(TMessage &msg)
{
	msg.Result = GetActive()->EvUpdate(msg);
}
void TSquFrame::EvMenuSelect(TMessage &msg)
{
	msg.Result = GetActive()->EvMenuSelect(msg);
}
void TSquFrame::EvMenuKeyDown(TMessage &msg)
{
	msg.Result = GetActive()->EvMenuKeyDown(msg);
}
void TSquFrame::EvMenuKeyDown2(TMessage &msg)
{
	msg.Result = GetActive()->EvMenuKeyDown2(msg);
}
void TSquFrame::EvHyperLink(TMessage &msg)
{
	msg.Result = GetActive()->EvHyperLink(msg);
}
#endif
//---------------------------------------------------------------------------
//	Event Handlers - Page Control
//---------------------------------------------------------------------------
void __fastcall TSquFrame::SquareTabChange(TObject *Sender)
{
	if (!SetActive(SquareTab->ActivePage)){
		__assert__;	// programming error!?
	}
}
//---------------------------------------------------------------------------
void __fastcall TSquFrame::SquareTabDragOver(TObject *Sender,
	  TObject *Source, int X, int Y, TDragState State, bool &Accept)
{
	if (Sender->ClassNameIs("TTntPageControl"))
		Accept = true;
}
//---------------------------------------------------------------------------
void __fastcall TSquFrame::SquareTabEndDrag(TObject *Sender,
	  TObject *Target, int X, int Y)
{
	for (int i=0;i<SquareTab->PageCount;i++){
		RECT rc;
		memset(&rc, 0, sizeof(rc));
		SquareTab->Perform(TCM_GETITEMRECT, i, (int)&rc);
		if (PtInRect(&rc, Point(X, Y))){
			MoveActiveTab(i);
			break;
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TSquFrame::SquareTabMouseDown(TObject *Sender,
	  TMouseButton Button, TShiftState Shift, int X, int Y)
{
	SquareTab->BeginDrag(false, -1);
}
//---------------------------------------------------------------------------
// Deletegators
//---------------------------------------------------------------------------
// Płsearching searchtrue
bool TSquFrame::IsSearchingAll()
{
	foreach_square(squ){
		if (squ->IsSearching())
			return true;
	}
	return false;
}
void TSquFrame::StopSearchAll()
{
	foreach_square(squ){
		squ->StopSearch();
	}
}
bool TSquFrame::IdleProc()
{
	bool ret = true;	// done flag.
	foreach_square(squ){
		if (!squ->IdleProc()){
			ret = false;
		}
	}
	return ret;
}
void TSquFrame::LoadProfile()
{
//	TRegKey *key = prof.SetSection(PFS_COMMON);

	GetActive()->LoadProfile();		// load common profile
}
void TSquFrame::SaveProfile()
{
//	TRegKey *key = prof.SetSection(PFS_COMMON);
#if 0	// to be deleted. also in header.
	GetActive()->SaveProfile();
#endif
}

