//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include "tnlib.h"

#include "SquIF.h"
#include "Squ.h"
#include "SquViewFrm.h"
#include "SquFrm.h"
#include "SrchProc.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

TSquIF::TSquIF(TSquFrame *frame, TSquViewFrame *view, TSquUIMain *main)
{
	Frame = frame;
	View = view;
	Main = main;
	SrchProc = View->GetSrchProc();
	squ = new TSqu();
}
TSquIF::~TSquIF()
{
	if (squ)
		delete squ;
}
void TSquIF::Setup()
{
	View->Initialize();
//	squ->Setup(View->PaintBox->Canvas->Handle);
//	squ->SetOrg(View->Width, View->Height);
}
#if 0
void TSquIF::SetupView()
{
	squ->SetupView(View->PaintBox->Canvas->Handle);
}
void TSquIF::SetHWindow(HWND hwnd)
{
	squ->SetHWindow(hwnd);
}
#endif
void TSquIF::LoadProfile()
{
	//TODO: squ->LoadProfile();
}
#if 0
void TSquIF::SetOrg()
{
	squ->SetOrg(View->Width, View->Height);
}
void TSquIF::Open()
{
	squ->Open();
}
#endif
void TSquIF::Close()
{
	View->Cleanup();
	//squ->Close();
}
bool TSquIF::CanClose(bool withmsg)
{
	return true;
}
#if 0
void TSquIF::Clear()
{
	squ->Clear();
}
void TSquIF::Reset()
{
	squ->Reset();
}
void TSquIF::Escape()
{
	squ->Escape();
}
#endif
bool TSquIF::StartSearch(const tchar *pat, const tchar *dir, const tchar *mask, int option)
{
	return View->StartSearch(pat, dir, mask, option);
}
#if 0
void TSquIF::ResetSearch()
{
	squ->ResetSearch();
}
#endif
void TSquIF::StopSearch()
{
	View->GetSrchProc()->StopSearch();
}
#if 0
void TSquIF::EndSearch()
{
	squ->EndSearch();
}
#endif
bool TSquIF::IsSearching()
{
	return View->IsSearching();
}
void TSquIF::GetSearchParams(struct TSearchParams &params)
{
	View->GetSearchParams(params);
}

// Message //
void TSquIF::UpdateMsg()
{
	View->UpdateMsg();
}
#if 0
const tchar *TSquIF::GetMsg(int *pasttime)
{
	return View->GetMsg(pasttime);
}
// View //
void TSquIF::ResetFont()
{
	squ->ResetFont();
}
void TSquIF::ResetColor()
{
	squ->ResetColor();
}

// Commands //
void TSquIF::DeleteWord()
{
	squ->cmdDeleteWord();
}
void TSquIF::Copy(int id)
{
	squ->cmdCopy(id);
}
//---------------------------------------------------------------------------
//	Event Handlers
//---------------------------------------------------------------------------
LRESULT TSquIF::EvUpdate(TMessage msg)
{
	return squ->UmUpdate(msg.WParam, msg.LParam);
}
void TSquIF::EvActivate(bool active)
{
	squ->EvActivate(active);
}
#endif
//---------------------------------------------------------------------------
//	Result Items
//---------------------------------------------------------------------------
int TSquIF::GetItemCount()
{
	return View->lvResult->Items->Count;
}
//---------------------------------------------------------------------------
//	Result List
//---------------------------------------------------------------------------
HWND TSquIF::GetResultHandle()
{
	return View->lvResult->Handle;
}
void TSquIF::ResultSetFocus()
{
	View->lvResult->SetFocus();
}
void TSquIF::ResultSelDown()
{
	View->ResultSelDown();
}
void TSquIF::ResultSelUp()
{
	View->ResultSelUp();
}
void TSquIF::NextSelFile()
{
	View->NextSelFile();
}
void TSquIF::PrevSelFile()
{
	View->PrevSelFile();
}
void TSquIF::CopyResult()
{
	View->CopyResult();
}
void TSquIF::KeyEnter()
{
	View->KeyEnter();
}
void TSquIF::OpenTool()
{
	View->OpenTool();
}

#if 0
// Search //
int TSquIF::Search( const tchar *str, SrchMode mode, int dicno, GenericRexp *grexp, SrchOut *srchout, int level1, int level2, int MemOnOff )
{
	return squ->search(str, mode, dicno, grexp, srchout, level1, level2, MemOnOff);
}
bool TSquIF::SearchHistory( TSearchHistoryParam &shp )
{
	return squ->SearchHistory(shp);
}
#endif
bool TSquIF::IdleProc()
{
	//return squ->IdleProc();
	return View->IdleProc();
}
#if 0
void TSquIF::SetDeleteFile( const tchar *filename)
{
	squ->SetDeleteFile(filename);
}

//---------------------------------------------------------------------------
// History
//---------------------------------------------------------------------------
void TSquIF::MoveHistory( bool forward )
{
	squ->MoveHistory(forward);
}
bool TSquIF::CanMoveHistory( bool forward )
{
	return squ->CanMoveHistory(forward);
}
#endif

