//---------------------------------------------------------------------------

#ifndef SquIFH
#define SquIFH
//---------------------------------------------------------------------------

class SrchOut;
class TSqu;
class TPopupSearch;

class TSquIF {
private:
	class TSquFrame *Frame;
	class TSquViewFrame *View;
	class TSquUIMain *Main;
	class TSearchProcI *SrchProc;
	TSqu *squ;
public:
	TSquIF(class TSquFrame *frame, TSquViewFrame *view, TSquUIMain *main);
	virtual ~TSquIF();

	// getter //
	TSquViewFrame *GetView()
		{ return View; }
	TSqu *GetSquare()
		{ return squ; }
	TSquUIMain *GetMain()
		{ return Main; }
	TSearchProcI *GetSrchProc()
		{ return SrchProc; }
	
	// setup //
	void Setup();
	void SetupView();
	void SetHWindow(HWND hwnd);
	void LoadProfile();

	// dictionary //
	void Open();
	void Close();
	bool CanClose(bool withmsg);
	void Clear();
	void Reset( );
	void Escape();

	bool StartSearch(const tchar *pat, const tchar *dir, const tchar *mask, int option);
	void ResetSearch();
	void StopSearch();
	void EndSearch();

	bool IsSearching();

	void GetSearchParams(struct TSearchParams &);

	// Message //
	void UpdateMsg();
	//const tchar *GetMsg(int *pasttime);
	
	// View //
	void SetOrg();
	void Paint(HDC hdc, RECT &rc);
	void ResetFont();
	void ResetColor();
	void Invalidate();

	// Commands //
	void Copy(int part);

	// Event Handler //
	LRESULT EvUpdate(TMessage msg);
	LRESULT EvMenuSelect(TMessage msg);
	LRESULT EvMenuKeyDown(TMessage msg);
	LRESULT EvMenuKeyDown2(TMessage msg);
	LRESULT EvHyperLink(TMessage msg);
	void EvActivate(bool active);

	// Result Items //
	int GetItemCount();

	// Result List //
	HWND GetResultHandle();
	void ResultSetFocus();
	void ResultSelDown();
	void ResultSelUp();
	void NextSelFile();
	void PrevSelFile();
	void CopyResult();
	void KeyEnter();
	void OpenTool();

	// scroller //
	int ScrollDown(bool fClsRegion=false, bool down=false);		// Ԃl̓XN[Pꐔ
	int ScrollDown1(bool stopatoboom);
	int ScrollUp(bool fClsRegion=false);
	int LineScrollUp();
	int LineScrollDown();

	// Search //
#if 0
	int Search( const tchar *str, SrchMode mode, int dicno, GenericRexp *grexp, SrchOut *srchout=NULL, int level1=WA_MINLEVEL, int level2=WA_MAXLEVEL, int MemOnOff=0 );
	bool SearchHistory( struct TSearchHistoryParam &shp );
	void SearchFast(const tchar *str, SrchMode mode=(SrchMode)0, int diclist=0);
	void StartSpecialSearch(const tchar *str);
	void StartSubSearch(const tchar *str);
	void StopSubSearch();
#endif
	
	// Clipboard //
	void CopySelection();

	// Mouse hanlders //
	void LButtonDown(WPARAM wParam, LPARAM lParam);
	void MouseMove(WPARAM wParam, LPARAM lParam);
	void LButtonUp(WPARAM wParam, LPARAM lParam);

	// Timer handler //
	void Timer(UINT id);
	
	// Command //
	void CommandProc(int id) const;

	// Misc //
	bool IdleProc();

	// History //
	void MoveHistory( bool forward );
	bool CanMoveHistory( bool forward );
};

#endif
